import { DirectiveAnnotation } from '@graphql-tools/utils';
export interface IGenerateSqlOptions {
    databaseName: string;
    tablePrefix?: string;
    dbType?: 'mysql' | 'postgres' | 'sqlite';
}
export type Annotations = {
    typeAnnotations: TypeAnnotations;
    fieldAnnotations: FieldAnnotations;
};
export type TypeAnnotations = {
    [typeName: string]: DirectiveAnnotation;
};
export type FieldAnnotations = {
    [typeName: string]: {
        [fieldName: string]: {
            directive: DirectiveAnnotation;
            graphQLType: string;
        };
    };
};
export declare function generateSql(annotations: Annotations, options: IGenerateSqlOptions): string;
