import { IExecutableSchemaDefinition, SchemaDirectiveVisitor } from 'graphql-tools';
export interface IMakeSqlSchemaInput extends IExecutableSchemaDefinition {
    schemaDirectives: {
        [name: string]: typeof SchemaDirectiveVisitor;
    };
    outputFilepath: string;
    databaseName: string;
    tablePrefix?: string;
}
export interface ITable {
    name: string;
    columns: {
        [name: string]: IColumn;
    };
    primaryIndex?: IColumn;
    secondaryIndices?: IColumn[];
    unicode?: boolean;
    constraints?: string;
}
export interface IColumn {
    name: string;
    auto?: boolean;
    default?: string;
    index?: boolean;
    nullable?: boolean;
    primary?: boolean;
    type?: string;
    graphQLType: string;
    unicode?: boolean;
    unique?: boolean;
    generated?: string;
}
export interface ISQLAST {
    [name: string]: ITable;
}
export declare function addTable(table: ITable): void;
export declare function addColumn(tableName: string, column: IColumn): void;
export declare function makeMysqlSchema(options: IMakeSqlSchemaInput): void;
