const STRING_TYPES = [
    'CHAR',
    'VARCHAR',
    'BINARY',
    'VARBINARY',
    'BLOB',
    'TEXT',
    'ENUM',
    'SET',
];
export function generateSql(annotations, options) {
    const ast = convertIntoSqlAst(annotations, options);
    console.log('ast', ast);
    return '';
    // setDefaults()
    // gatherIndices()
    // return renderCreateSchemaScript(
    //   options.dbType || 'mysql',
    //   databaseName,
    //   tablePrefix,
    //   outputFilepath
    // )
}
function convertIntoSqlAst(annotations, options) {
    const ast = {};
    const tablePrefix = options.tablePrefix ? `${options.tablePrefix}_` : '';
    for (const typeName of Object.keys(annotations.typeAnnotations)) {
        const directive = annotations.typeAnnotations[typeName];
        const table = {
            name: `${tablePrefix}${typeName}`,
            columns: {},
            ...directive.args
        };
        ast[typeName] = table;
    }
    return ast;
}
// function setDefaults() {
//   forEachTableDo(table => {
//     forEachColumnDo(table, column => {
//       if (column.primary && column.nullable) {
//         emitError(
//           table.name,
//           column.name,
//           '@primary is not allowed with @nullable.'
//         )
//       }
//
//       if (!column.type) {
//         if (column.graphQLType === 'String') {
//           emitError(
//             table.name,
//             column.name,
//             `String types must be explicitly defined using @type.`
//           )
//         } else if (column.graphQLType === 'Int') {
//           column.type = 'INT'
//         } else if (column.graphQLType === 'Float') {
//           column.type = 'DECIMAL'
//         } else if (column.graphQLType === 'Boolean') {
//           column.type = 'BOOLEAN'
//         } else if (column.graphQLType === 'JSON') {
//           column.type = 'JSON'
//         } else {
//           emitError(
//             table.name,
//             column.name,
//             `A default SQL type cannot be generated for GraphQL type ${column.graphQLType}`
//           )
//         }
//       }
//
//       column.type = (column.type || '').toUpperCase()
//
//       if (column.auto) {
//         // @ts-ignore
//         if (!column.type.includes('INT') && column.type !== 'SERIAL') {
//           emitError(
//             table.name,
//             column.name,
//             `Column with "auto" must have INT or SERIAL type.`
//           )
//         }
//         if (column.default) {
//           emitError(
//             table.name,
//             column.name,
//             '"default" is not allowed with "auto".'
//           )
//         }
//         if (column.unicode) {
//           emitError(
//             table.name,
//             column.name,
//             '"unicode" is not allowed with "auto".'
//           )
//         }
//         if (column.generated) {
//           emitError(
//             table.name,
//             column.name,
//             '"generated" is not allowed with "auto".'
//           )
//         }
//       }
//
//       if (column.unicode) {
//         // @ts-ignore
//         if (!STRING_TYPES.includes(stripLength(column.type))) {
//           emitError(
//             table.name,
//             column.name,
//             '@unicode can only be applied to a string type.'
//           )
//         }
//         if (!table.unicode) {
//           table.unicode = true
//         }
//       }
//
//       if (column.generated && column.default) {
//         emitError(
//           table.name,
//           column.name,
//           '"default" is not allowed with "generated".'
//         )
//       }
//
//       if (column.generated && column.generated.startsWith('ALWAYS AS')) {
//         column.generated = `GENERATED ${column.generated}`
//       }
//
//       if (
//         column.generated &&
//         !column.generated.startsWith('GENERATED') &&
//         !column.generated.startsWith('AS')
//       ) {
//         column.generated = `AS ${column.generated}`
//       }
//     })
//   })
// }
//
// function gatherIndices() {
//   forEachTableDo(table => {
//     forEachColumnDo(table, column => {
//       if (column.primary) {
//         table.primaryIndices = table.primaryIndices || []
//         table.primaryIndices.push(column)
//       } else if (column.index) {
//         table.secondaryIndices = table.secondaryIndices || []
//         table.secondaryIndices.push(column)
//       }
//     })
//     if (!table.primaryIndices || table.primaryIndices?.length === 0) {
//       emitError(
//         table.name,
//         '',
//         `Table ${table.name} does not have a primary index.`
//       )
//     }
//   })
// }
//
// function renderCreateSchemaScript(
//   dbType: string,
//   databaseName: string,
//   tablePrefix: string,
//   outputFilepath?: string
// ): string {
//   // console.log('Creating script from:', JSON.stringify(sqlAST, null, '  '))
//
//   const tableDefinitions: string[] = []
//   forEachTableDo(table => {
//     const columnDefinitions: string[] = []
//     forEachColumnDo(table, column => {
//       const unicodeClause = !!column.unicode
//         ? 'CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci '
//         : ''
//       const generatedClause = !!column.generated ? `${column.generated} ` : ''
//       const nullClause = !!column.nullable ? 'NULL ' : 'NOT NULL '
//       const defaultClause = !!column.default ? `DEFAULT ${column.default} ` : ''
//       const autoClause =
//         !!column.auto && column.type !== 'SERIAL' ? 'AUTO_INCREMENT ' : ''
//       const uniqueClause = !!column.unique ? `UNIQUE ` : ''
//       columnDefinitions.push(
//         `\`${column.name}\` ${column.type} ${unicodeClause}${generatedClause}${nullClause}${defaultClause}${autoClause}${uniqueClause}`.trim()
//       )
//     })
//
//     // const primaryKeyNames = (table.primaryIndices && table.primaryIndices[0].name) || ''
//     const primaryKeyNames = table.primaryIndices && table.primaryIndices.length ?
//       table.primaryIndices.map(column => `\`${column.name}\``).join(', ') : ''
//
//     let indexDefinitions =
//       dbType === 'mysql'
//         ? (table.secondaryIndices || []).map(column => {
//             return `INDEX \`${column.name.toUpperCase()}INDEX\` (\`${
//               column.name
//             }\` ASC)`
//           })
//         : (table.secondaryIndices || []).map(column => {
//             return `CREATE INDEX \`${column.name.toUpperCase()}INDEX\` ON \`${databaseName}\`.\`${tablePrefix}${
//               table.name
//             }\` (\`${column.name}\` ASC)`
//           })
//     if (indexDefinitions.length > 0) {
//       indexDefinitions = [''].concat(indexDefinitions)
//     }
//
//     const constraints = table.constraints ? ',\n  ' + table.constraints : ''
//     // let constraints = (table.constraints || '').split(/,\s*/).join(',\n  ')
//     // constraints = constraints ? ',\n  ' + constraints : ''
//
//     const unicodeModifier = table.unicode
//       ? ' CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci'
//       : ''
//
//     if (dbType === 'mysql') {
//       tableDefinitions.push(
//         `CREATE TABLE \`${databaseName}\`.\`${tablePrefix}${table.name}\` (
//   ${columnDefinitions.join(',\n  ')},
//   PRIMARY KEY (${primaryKeyNames})${indexDefinitions.join(
//           ',\n  '
//         )}${constraints}
// )${unicodeModifier};`
//       )
//     } else if (dbType === 'postgres') {
//       tableDefinitions.push(
//         `CREATE TABLE \`${databaseName}\`.\`${tablePrefix}${table.name}\` (
//   ${columnDefinitions.join(',\n  ')},
//   PRIMARY KEY (${primaryKeyNames})${constraints}
// )${indexDefinitions.join(';\n')};`
//       )
//     }
//   })
//
//   let render = `CREATE SCHEMA IF NOT EXISTS ${databaseName};\n\n` + tableDefinitions.join('\n\n')
//
//   if (dbType === 'postgres') {
//     render = render.replace(/`/g, '')
//   }
//
//   if (outputFilepath) {
//     fs.outputFileSync(outputFilepath, render)
//   }
//   return render
// }
//
// function forEachTableDo(foo: (table: ITable) => void): void {
//   for (const tableName in sqlAST) {
//     if (!sqlAST.hasOwnProperty(tableName)) continue
//     const table: ITable = sqlAST[tableName]
//     foo(table)
//   }
// }
//
// function forEachColumnDo(table: ITable, foo: (column: IColumn) => void): void {
//   for (const columnName in table.columns) {
//     if (!table.columns.hasOwnProperty(columnName)) continue
//     const column: IColumn = table.columns[columnName]
//     foo(column)
//   }
// }
//
// function emitError(
//   tableName: string,
//   columnName: string,
//   message: string
// ): void {
//   throw new Error(`[${tableName} : ${columnName}]: ${message}`)
// }
//
// function stripLength(type: string): string {
//   return type.split('(')[0]
// }
